## libdeflate 1.2

=== Makefile ===
#
# Use 'make help' to list available targets.
#
# Define V=1 to enable "verbose" mode, showing all executed commands.
#
# Define DECOMPRESSION_ONLY to omit all compression code, building a
# decompression-only library.  If doing this, you must also build a specific
# library target such as 'libdeflate.a', as the programs will no longer compile.
#
# Define DISABLE_GZIP to disable support for the gzip wrapper format.
#
# Define DISABLE_ZLIB to disable support for the zlib wrapper format.
#
##############################################################################

#### Common compiler flags.
#### Flags given here are not intended to be overridden, but you can add more
#### by defining CFLAGS in the environment or on the 'make' command line.

cc-option = $(shell if $(CC) $(1) -c -x c /dev/null -o /dev/null \
	      1>&2 2>/dev/null; then echo $(1); fi)

override CFLAGS :=							\
	$(CFLAGS) -O2 -fomit-frame-pointer -std=c99 -I. -Icommon	\
	-Wall -Wundef							\
	$(call cc-option,-Wpedantic)					\
	$(call cc-option,-Wdeclaration-after-statement)			\
	$(call cc-option,-Wmissing-prototypes)				\
	$(call cc-option,-Wstrict-prototypes)				\
	$(call cc-option,-Wvla)

# We don't define any CPPFLAGS, but support the user specifying it.

##############################################################################

PREFIX ?= /usr

SOVERSION          := 0
STATIC_LIB_SUFFIX  := .a
SHARED_LIB_SUFFIX  := .so.$(SOVERSION)
SHARED_LIB_CFLAGS  := -fPIC
SHARED_LIB_LDFLAGS := -Wl,-soname=libdeflate$(SHARED_LIB_SUFFIX)
PROG_SUFFIX        :=
PROG_CFLAGS        :=
HARD_LINKS         := 1

# Compiling for Windows with MinGW?
ifneq ($(findstring -mingw,$(shell $(CC) -dumpmachine 2>/dev/null)),)
    SOVERSION          :=
    STATIC_LIB_SUFFIX  := static.lib
    SHARED_LIB_SUFFIX  := .dll
    SHARED_LIB_CFLAGS  :=
    SHARED_LIB_LDFLAGS := -Wl,--out-implib,libdeflate.lib
    PROG_SUFFIX        := .exe
    PROG_CFLAGS        := -static -municode
    HARD_LINKS         :=
    override CFLAGS    := $(CFLAGS) $(call cc-option,-Wno-pedantic-ms-format)

    # If AR was not already overridden, then derive it from $(CC).
    # Note that CC may take different forms, e.g. "cc", "gcc",
    # "x86_64-w64-mingw32-gcc", or "x86_64-w64-mingw32-gcc-6.3.1".
    # On Windows it may also have a .exe extension.
    ifeq ($(AR),ar)
        AR := $(shell echo $(CC) | \
                sed -E 's/g?cc(-?[0-9]+(\.[0-9]+)*)?(\.exe)?$$/ar\3/')
    endif
endif

##############################################################################

#### Quiet make is enabled by default.  Define V=1 to disable.

ifneq ($(findstring s,$(MAKEFLAGS)),s)
ifneq ($(V),1)
        QUIET_CC       = @echo '  CC      ' $@;
        QUIET_CCLD     = @echo '  CCLD    ' $@;
        QUIET_AR       = @echo '  AR      ' $@;
        QUIET_LN       = @echo '  LN      ' $@;
        QUIET_CP       = @echo '  CP      ' $@;
        QUIET_GEN      = @echo '  GEN     ' $@;
endif
endif

##############################################################################

COMMON_HEADERS := $(wildcard common/*.h) libdeflate.h
DEFAULT_TARGETS :=

#### Library

STATIC_LIB := libdeflate$(STATIC_LIB_SUFFIX)
SHARED_LIB := libdeflate$(SHARED_LIB_SUFFIX)

LIB_CFLAGS += $(CFLAGS) -fvisibility=hidden -D_ANSI_SOURCE

LIB_HEADERS := $(wildcard lib/*.h) $(wildcard lib/*/*.h)

LIB_SRC := lib/aligned_malloc.c lib/deflate_decompress.c \
	   $(wildcard lib/*/cpu_features.c)

DECOMPRESSION_ONLY :=
ifndef DECOMPRESSION_ONLY
    LIB_SRC += lib/deflate_compress.c
endif

DISABLE_ZLIB :=
ifndef DISABLE_ZLIB
    LIB_SRC += lib/adler32.c lib/zlib_decompress.c
    ifndef DECOMPRESSION_ONLY
        LIB_SRC += lib/zlib_compress.c
    endif
endif

DISABLE_GZIP :=
ifndef DISABLE_GZIP
    LIB_SRC += lib/crc32.c lib/gzip_decompress.c
    ifndef DECOMPRESSION_ONLY
        LIB_SRC += lib/gzip_compress.c
    endif
endif

STATIC_LIB_OBJ := $(LIB_SRC:.c=.o)
SHARED_LIB_OBJ := $(LIB_SRC:.c=.shlib.o)

# Compile static library object files
$(STATIC_LIB_OBJ): %.o: %.c $(LIB_HEADERS) $(COMMON_HEADERS) .lib-cflags
	$(QUIET_CC) $(CC) -o $@ -c $(CPPFLAGS) $(LIB_CFLAGS) $<

# Compile shared library object files
$(SHARED_LIB_OBJ): %.shlib.o: %.c $(LIB_HEADERS) $(COMMON_HEADERS) .lib-cflags
	$(QUIET_CC) $(CC) -o $@ -c $(CPPFLAGS) $(LIB_CFLAGS) \
		$(SHARED_LIB_CFLAGS) -DLIBDEFLATE_DLL $<

# Create static library
$(STATIC_LIB):$(STATIC_LIB_OBJ)
	$(QUIET_AR) $(AR) cr $@ $+

DEFAULT_TARGETS += $(STATIC_LIB)

# Create shared library
$(SHARED_LIB):$(SHARED_LIB_OBJ)
	$(QUIET_CCLD) $(CC) -o $@ $(LDFLAGS) $(LIB_CFLAGS) \
		$(SHARED_LIB_LDFLAGS) -shared $+

DEFAULT_TARGETS += $(SHARED_LIB)

ifdef SOVERSION
# Create the symlink libdeflate.so => libdeflate.so.$SOVERSION
libdeflate.so:$(SHARED_LIB)
	$(QUIET_LN) ln -sf $+ $@
DEFAULT_TARGETS += libdeflate.so
endif

# Rebuild if CC, LIB_CFLAGS, or CPPFLAGS changed
.lib-cflags: FORCE
	@flags='$(CC):$(LIB_CFLAGS):$(CPPFLAGS)'; \
	if [ "$$flags" != "`cat $@ 2>/dev/null`" ]; then \
		[ -e $@ ] && echo "Rebuilding library due to new compiler flags"; \
		echo "$$flags" > $@; \
	fi

##############################################################################

#### Programs

PROG_CFLAGS += $(CFLAGS)		 \
	       -D_POSIX_C_SOURCE=200809L \
	       -D_FILE_OFFSET_BITS=64	 \
	       -DHAVE_CONFIG_H

ALL_PROG_COMMON_HEADERS := programs/config.h \
			   programs/prog_util.h \
			   programs/test_util.h
PROG_COMMON_SRC      := programs/prog_util.c \
			programs/tgetopt.c
NONTEST_PROG_SRC     := programs/gzip.c
TEST_PROG_COMMON_SRC := programs/test_util.c
TEST_PROG_SRC        := programs/benchmark.c \
			programs/checksum.c \
			programs/test_checksums.c \
			programs/test_incomplete_codes.c \
			programs/test_slow_decompression.c

NONTEST_PROGRAMS := $(NONTEST_PROG_SRC:programs/%.c=%$(PROG_SUFFIX))
DEFAULT_TARGETS  += $(NONTEST_PROGRAMS)
TEST_PROGRAMS    := $(TEST_PROG_SRC:programs/%.c=%$(PROG_SUFFIX))

PROG_COMMON_OBJ      := $(PROG_COMMON_SRC:%.c=%.o)
NONTEST_PROG_OBJ     := $(NONTEST_PROG_SRC:%.c=%.o)
TEST_PROG_COMMON_OBJ := $(TEST_PROG_COMMON_SRC:%.c=%.o)
TEST_PROG_OBJ        := $(TEST_PROG_SRC:%.c=%.o)

ALL_PROG_OBJ	     := $(PROG_COMMON_OBJ) $(NONTEST_PROG_OBJ) \
			$(TEST_PROG_COMMON_OBJ) $(TEST_PROG_OBJ)

# Generate autodetected configuration header
programs/config.h:programs/detect.sh .prog-cflags
	$(QUIET_GEN) CC="$(CC)" CFLAGS="$(PROG_CFLAGS)" $< > $@

# Compile program object files
$(ALL_PROG_OBJ): %.o: %.c $(ALL_PROG_COMMON_HEADERS) $(COMMON_HEADERS) \
			.prog-cflags
	$(QUIET_CC) $(CC) -o $@ -c $(CPPFLAGS) $(PROG_CFLAGS) $<

# Link the programs.
#
# Note: the test programs are not compiled by default.  One reason is that the
# test programs must be linked with zlib for doing comparisons.

$(NONTEST_PROGRAMS): %$(PROG_SUFFIX): programs/%.o $(PROG_COMMON_OBJ) \
			$(STATIC_LIB)
	$(QUIET_CCLD) $(CC) -o $@ $(LDFLAGS) $(PROG_CFLAGS) $+

$(TEST_PROGRAMS): %$(PROG_SUFFIX): programs/%.o $(PROG_COMMON_OBJ) \
			$(TEST_PROG_COMMON_OBJ) $(STATIC_LIB)
	$(QUIET_CCLD) $(CC) -o $@ $(LDFLAGS) $(PROG_CFLAGS) $+ -lz

ifdef HARD_LINKS
# Hard link gunzip to gzip
gunzip$(PROG_SUFFIX):gzip$(PROG_SUFFIX)
	$(QUIET_LN) ln -f $< $@
else
# No hard links; copy gzip to gunzip
gunzip$(PROG_SUFFIX):gzip$(PROG_SUFFIX)
	$(QUIET_CP) cp -f $< $@
endif

DEFAULT_TARGETS += gunzip$(PROG_SUFFIX)

# Rebuild if CC, PROG_CFLAGS, or CPPFLAGS changed
.prog-cflags: FORCE
	@flags='$(CC):$(PROG_CFLAGS):$(CPPFLAGS)'; \
	if [ "$$flags" != "`cat $@ 2>/dev/null`" ]; then \
		[ -e $@ ] && echo "Rebuilding programs due to new compiler flags"; \
		echo "$$flags" > $@; \
	fi

##############################################################################

all:$(DEFAULT_TARGETS)

install:all
	install -Dm644 -t $(DESTDIR)$(PREFIX)/lib $(STATIC_LIB)
	install -Dm755 -t $(DESTDIR)$(PREFIX)/lib $(SHARED_LIB)
	ln -sf $(SHARED_LIB) $(DESTDIR)$(PREFIX)/lib/libdeflate.so
	install -Dm644 -t $(DESTDIR)$(PREFIX)/include libdeflate.h
	install -Dm755 gzip $(DESTDIR)$(PREFIX)/bin/libdeflate-gzip
	ln -f $(DESTDIR)$(PREFIX)/bin/libdeflate-gzip $(DESTDIR)$(PREFIX)/bin/libdeflate-gunzip

uninstall:
	rm -f $(DESTDIR)$(PREFIX)/lib/$(STATIC_LIB) \
		$(DESTDIR)$(PREFIX)/lib/$(SHARED_LIB) \
		$(DESTDIR)$(PREFIX)/lib/libdeflate.so \
		$(DESTDIR)$(PREFIX)/include/libdeflate.h \
		$(DESTDIR)$(PREFIX)/bin/libdeflate-gzip \
		$(DESTDIR)$(PREFIX)/bin/libdeflate-gunzip

test_programs:$(TEST_PROGRAMS)

help:
	@echo "Available targets:"
	@echo "------------------"
	@for target in $(DEFAULT_TARGETS) $(TEST_PROGRAMS); do \
		echo -e "$$target";		\
	done

clean:
	rm -f *.a *.dll *.exe *.exp *.so \
		lib/*.o lib/*/*.o \
		lib/*.obj lib/*/*.obj \
		lib/*.dllobj lib/*/*.dllobj \
		programs/*.o programs/*.obj \
		$(DEFAULT_TARGETS) $(TEST_PROGRAMS) programs/config.h \
		libdeflate.lib libdeflatestatic.lib \
		.lib-cflags .prog-cflags

realclean: clean
	rm -f tags cscope* run_tests.log

FORCE:

.PHONY: all install uninstall test_programs help clean realclean

.DEFAULT_GOAL = all

=== debian/changelog ===
libdeflate (1.2-1) unstable; urgency=medium

  * New upstream version
  * Compile using profile guided optimization

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 15 Jan 2019 06:05:37 -0800

libdeflate (1.1-1) unstable; urgency=medium

  * New upstream version
  * Remove all patches, they were applied upstream.

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sun, 23 Dec 2018 15:02:48 -0800

libdeflate (1.0-5) unstable; urgency=medium

  * debian/patches/add_cppflags: Add CPPFLAGS to implicit rule overrides
  * debian/watch: skip pre-releases
  * debian/tests, debian/control: add basic autopkgtest

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 19 Dec 2018 02:55:01 -0800

libdeflate (1.0-4) unstable; urgency=medium

  [ Andreas Tille ]
  * ARM: NEON is not available with the FPU emulation (Thanks to Adrian Bunk
    for the patch)
    Closes: #916700

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 18 Dec 2018 01:11:20 -0800

libdeflate (1.0-3) unstable; urgency=medium

  * debian/patches/armel_no_neon: use a more direct method of disabling
    NEON on the armel architecture.

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Fri, 07 Dec 2018 02:37:13 -0800

libdeflate (1.0-2) unstable; urgency=medium

  * debian/rules: Try turning off NEON on armel to fix the build; ask
    upstream's build to be more verbose
  * debian/control: Add "Multi-Arch: same" hints
  * debian/libdeflate0.symbols: add Build-Depends-Package

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Thu, 06 Dec 2018 19:52:52 -0800

libdeflate (1.0-1) unstable; urgency=medium

  * Initial release (Closes: #911076)

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 15 Oct 2018 01:59:04 -0700

=== debian/rules ===
#!/usr/bin/make -f

# for hardening you might like to uncomment this:
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@


override_dh_auto_build:
	make CFLAGS="$(shell dpkg-buildflags --get CFLAGS) -fprofile-generate" \
		LDFLAGS="$(shell dpkg-buildflags --get LDFLAGS) -fprofile-generate"\
		V=1 all test_programs -j$(shell nproc) \
		"INSTALL=install --strip-program=true"
	for level in $(shell seq 1 12); do \
		./benchmark -$${level} ./lib/deflate_compress.c > /dev/null; \
	done
	make CFLAGS="$(shell dpkg-buildflags --get CFLAGS) -fprofile-use" \
		V=1 all test_programs -j$(shell nproc) \
		"INSTALL=install --strip-program=true"

override_dh_auto_install:
	make CFLAGS="$(shell dpkg-buildflags --get CFLAGS) -fprofile-use" \
		-j$(shell nproc) install DESTDIR=$(CURDIR)/debian/tmp \
		AM_UPDATE_INFO_DIR=no "INSTALL=install --strip-program=true"	

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cp -a README.md README.md.save
	./gzip README.md
	./gunzip README.md.gz
	diff -u README.md.save README.md && rm README.md.save
	./test_checksums 
	./checksum -A -t README.md
	./checksum -t README.md
endif

override_dh_install:
	dh_install
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --movedev libdeflate.h usr/include \
		    *.so

=== debian/tests/control ===
Tests: compile-sample-programs
Depends: @, gcc, bash, libc6-dev

## libdeflate 1.5

=== Makefile ===
--- 
+++ 
@@ -11,46 +11,70 @@
 #
 # Define DISABLE_ZLIB to disable support for the zlib wrapper format.
 #
-##############################################################################
-
-#### Common compiler flags.
-#### Flags given here are not intended to be overridden, but you can add more
-#### by defining CFLAGS in the environment or on the 'make' command line.
+# Define PREFIX to override the installation prefix, like './configure --prefix'
+# in autotools-based projects (default: /usr/local)
+#
+# Define BINDIR to override where to install binaries, like './configure
+# --bindir' in autotools-based projects (default: PREFIX/bin)
+#
+# Define INCDIR to override where to install headers, like './configure
+# --includedir' in autotools-based projects (default: PREFIX/include)
+#
+# Define LIBDIR to override where to install libraries, like './configure
+# --libdir' in autotools-based projects (default: PREFIX/lib)
+#
+# Define DESTDIR to override the installation destination directory
+# (default: empty string)
+#
+# You can also specify custom CFLAGS, CPPFLAGS, and/or LDFLAGS.
+#
+##############################################################################
+
+#### Common compiler flags.  You can add additional flags by defining CFLAGS
+#### in the environment or on the 'make' command line.
+####
+#### The default optimization flags can be overridden, e.g. via CFLAGS="-O3" or
+#### CFLAGS="-O0 -fno-omit-frame-pointer".  But this usually isn't recommended;
+#### you're unlikely to get significantly better performance even with -O3.
 
 cc-option = $(shell if $(CC) $(1) -c -x c /dev/null -o /dev/null \
 	      1>&2 2>/dev/null; then echo $(1); fi)
 
 override CFLAGS :=							\
-	$(CFLAGS) -O2 -fomit-frame-pointer -std=c99 -I. -Icommon	\
+	-O2 -fomit-frame-pointer $(CFLAGS) -std=c99 -I. -Icommon	\
 	-Wall -Wundef							\
 	$(call cc-option,-Wpedantic)					\
 	$(call cc-option,-Wdeclaration-after-statement)			\
 	$(call cc-option,-Wmissing-prototypes)				\
 	$(call cc-option,-Wstrict-prototypes)				\
-	$(call cc-option,-Wvla)
+	$(call cc-option,-Wvla)						\
+	$(call cc-option,-Wimplicit-fallthrough)
 
 # We don't define any CPPFLAGS, but support the user specifying it.
 
 ##############################################################################
 
-PREFIX ?= /usr
+PREFIX ?= /usr/local
+BINDIR ?= $(PREFIX)/bin
+INCDIR ?= $(PREFIX)/include
+LIBDIR ?= $(PREFIX)/lib
 
 SOVERSION          := 0
+
 STATIC_LIB_SUFFIX  := .a
-SHARED_LIB_SUFFIX  := .so.$(SOVERSION)
-SHARED_LIB_CFLAGS  := -fPIC
-SHARED_LIB_LDFLAGS := -Wl,-soname=libdeflate$(SHARED_LIB_SUFFIX)
 PROG_SUFFIX        :=
 PROG_CFLAGS        :=
 HARD_LINKS         := 1
 
 # Compiling for Windows with MinGW?
 ifneq ($(findstring -mingw,$(shell $(CC) -dumpmachine 2>/dev/null)),)
-    SOVERSION          :=
     STATIC_LIB_SUFFIX  := static.lib
-    SHARED_LIB_SUFFIX  := .dll
+    SHARED_LIB         := libdeflate.dll
+    SHARED_LIB_SYMLINK :=
     SHARED_LIB_CFLAGS  :=
-    SHARED_LIB_LDFLAGS := -Wl,--out-implib,libdeflate.lib
+    SHARED_LIB_LDFLAGS := -Wl,--out-implib,libdeflate.lib \
+                          -Wl,--output-def,libdeflate.def \
+                          -Wl,--add-stdcall-alias
     PROG_SUFFIX        := .exe
     PROG_CFLAGS        := -static -municode
     HARD_LINKS         :=
@@ -64,6 +88,20 @@
         AR := $(shell echo $(CC) | \
                 sed -E 's/g?cc(-?[0-9]+(\.[0-9]+)*)?(\.exe)?$$/ar\3/')
     endif
+
+# macOS?
+else ifeq ($(shell uname),Darwin)
+   SHARED_LIB         := libdeflate.$(SOVERSION).dylib
+   SHARED_LIB_SYMLINK := libdeflate.dylib
+   SHARED_LIB_CFLAGS  := -fPIC
+   SHARED_LIB_LDFLAGS := -install_name $(SHARED_LIB)
+
+# Linux, FreeBSD, etc.
+else
+   SHARED_LIB         := libdeflate.so.$(SOVERSION)
+   SHARED_LIB_SYMLINK := libdeflate.so
+   SHARED_LIB_CFLAGS  := -fPIC
+   SHARED_LIB_LDFLAGS := -Wl,-soname=$(SHARED_LIB)
 endif
 
 ##############################################################################
@@ -89,7 +127,6 @@
 #### Library
 
 STATIC_LIB := libdeflate$(STATIC_LIB_SUFFIX)
-SHARED_LIB := libdeflate$(SHARED_LIB_SUFFIX)
 
 LIB_CFLAGS += $(CFLAGS) -fvisibility=hidden -D_ANSI_SOURCE
 
@@ -144,11 +181,11 @@
 
 DEFAULT_TARGETS += $(SHARED_LIB)
 
-ifdef SOVERSION
+ifdef SHARED_LIB_SYMLINK
 # Create the symlink libdeflate.so => libdeflate.so.$SOVERSION
-libdeflate.so:$(SHARED_LIB)
+$(SHARED_LIB_SYMLINK):$(SHARED_LIB)
 	$(QUIET_LN) ln -sf $+ $@
-DEFAULT_TARGETS += libdeflate.so
+DEFAULT_TARGETS += $(SHARED_LIB_SYMLINK)
 endif
 
 # Rebuild if CC, LIB_CFLAGS, or CPPFLAGS changed
@@ -239,23 +276,34 @@
 
 all:$(DEFAULT_TARGETS)
 
+# Install the files.  Note: not all versions of the 'install' program have the
+# '-D' and '-t' options, so don't use them; use portable commands only.
 install:all
-	install -Dm644 -t $(DESTDIR)$(PREFIX)/lib $(STATIC_LIB)
-	install -Dm755 -t $(DESTDIR)$(PREFIX)/lib $(SHARED_LIB)
-	ln -sf $(SHARED_LIB) $(DESTDIR)$(PREFIX)/lib/libdeflate.so
-	install -Dm644 -t $(DESTDIR)$(PREFIX)/include libdeflate.h
-	install -Dm755 gzip $(DESTDIR)$(PREFIX)/bin/libdeflate-gzip
-	ln -f $(DESTDIR)$(PREFIX)/bin/libdeflate-gzip $(DESTDIR)$(PREFIX)/bin/libdeflate-gunzip
+	install -d $(DESTDIR)$(LIBDIR) $(DESTDIR)$(INCDIR) $(DESTDIR)$(BINDIR)
+	install -m644 $(STATIC_LIB) $(DESTDIR)$(LIBDIR)
+	install -m755 $(SHARED_LIB) $(DESTDIR)$(LIBDIR)
+	ln -sf $(SHARED_LIB) $(DESTDIR)$(LIBDIR)/libdeflate.so
+	install -m644 libdeflate.h $(DESTDIR)$(INCDIR)
+	install -m755 gzip $(DESTDIR)$(BINDIR)/libdeflate-gzip
+	ln -f $(DESTDIR)$(BINDIR)/libdeflate-gzip $(DESTDIR)$(BINDIR)/libdeflate-gunzip
 
 uninstall:
-	rm -f $(DESTDIR)$(PREFIX)/lib/$(STATIC_LIB) \
-		$(DESTDIR)$(PREFIX)/lib/$(SHARED_LIB) \
-		$(DESTDIR)$(PREFIX)/lib/libdeflate.so \
-		$(DESTDIR)$(PREFIX)/include/libdeflate.h \
-		$(DESTDIR)$(PREFIX)/bin/libdeflate-gzip \
-		$(DESTDIR)$(PREFIX)/bin/libdeflate-gunzip
+	rm -f $(DESTDIR)$(LIBDIR)/$(STATIC_LIB) \
+		$(DESTDIR)$(LIBDIR)/$(SHARED_LIB) \
+		$(DESTDIR)$(LIBDIR)/libdeflate.so \
+		$(DESTDIR)$(INCDIR)/libdeflate.h \
+		$(DESTDIR)$(BINDIR)/libdeflate-gzip \
+		$(DESTDIR)$(BINDIR)/libdeflate-gunzip
 
 test_programs:$(TEST_PROGRAMS)
+
+# A minimal 'make check' target.  This only runs some quick tests;
+# use tools/run_tests.sh if you want to run the full tests.
+check:test_programs
+	./benchmark$(PROG_SUFFIX) < ./benchmark$(PROG_SUFFIX)
+	for prog in test_*; do		\
+		./$$prog || exit 1;	\
+	done
 
 help:
 	@echo "Available targets:"
@@ -271,7 +319,7 @@
 		lib/*.dllobj lib/*/*.dllobj \
 		programs/*.o programs/*.obj \
 		$(DEFAULT_TARGETS) $(TEST_PROGRAMS) programs/config.h \
-		libdeflate.lib libdeflatestatic.lib \
+		libdeflate.lib libdeflate.def libdeflatestatic.lib \
 		.lib-cflags .prog-cflags
 
 realclean: clean

=== debian/changelog ===
libdeflate (1.5-3) unstable; urgency=medium

  * Source only upload

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 12 Feb 2020 18:04:25 +0100

libdeflate (1.5-2) unstable; urgency=medium

  * Standards-Version: 4.5.0 (routine-update)
  * Remove obsolete fields Name from debian/upstream/metadata.
  * New binary package libdeflate-tools

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 10 Feb 2020 12:57:43 +0100

libdeflate (1.5-1) unstable; urgency=medium

  * New upstream version

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 01 Jan 2020 11:45:12 +0100

libdeflate (1.4-1) unstable; urgency=medium

  * New upstream version

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sat, 28 Dec 2019 12:00:11 +0100

libdeflate (1.3-3) unstable; urgency=medium

  * Drop valgrind build-dep

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Fri, 13 Sep 2019 15:28:11 +0200

libdeflate (1.3-2) unstable; urgency=medium

  * add patch from upstream: test_slow_decompression: skip by default since it's flaky
    Should fix build on ppc64el

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Fri, 13 Sep 2019 13:24:25 +0200

libdeflate (1.3-1) unstable; urgency=medium

  * New upstream version, now provides libdeflate-g{un,}zip in /usr/bin
  * debhelper-compat 12
  * Standards-Version: 4.4.0
  * Remove trailing whitespace in debian/rules
  * Set upstream metadata fields: Name.

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Fri, 23 Aug 2019 12:28:07 +0200

=== debian/control ===
Source: libdeflate
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12),
               d-shlibs,
               zlib1g-dev,
               python3 <!nocheck>,
               xxd <!nocheck>
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/libdeflate
Vcs-Git: https://salsa.debian.org/med-team/libdeflate.git
Homepage: https://github.com/ebiggers/libdeflate

Package: libdeflate0
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: fast, whole-buffer DEFLATE-based compression and decompression
 The supported formats are:
  * DEFLATE (raw)
  * zlib (a.k.a. DEFLATE with a zlib wrapper)
  * gzip (a.k.a. DEFLATE with a gzip wrapper)
 .
 libdeflate is heavily optimized. It is significantly faster than the zlib
 library, both for compression and decompression, and especially on x86
 processors. In addition, libdeflate provides optional high compression modes
 that provide a better compression ratio than the zlib's "level 9".

Package: libdeflate-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libdeflate0 (= ${binary:Version}),
         ${misc:Depends}
Description: headers for whole-buffer compression and decompression library
 The supported formats are:
  * DEFLATE (raw)
  * zlib (a.k.a. DEFLATE with a zlib wrapper)
  * gzip (a.k.a. DEFLATE with a gzip wrapper)
 .
 libdeflate is heavily optimized. It is significantly faster than the zlib
 library, both for compression and decompression, and especially on x86
 processors. In addition, libdeflate provides optional high compression modes
 that provide a better compression ratio than the zlib's "level 9".
 .
 This package provides the development headers.

Package: libdeflate-tools
Architecture: any
Section: libdevel
Depends: libdeflate0 (= ${binary:Version}),
         ${misc:Depends}, ${shlibs:Depends}
Description: tools for whole-buffer compression and decompression library
 The supported formats are:
  * DEFLATE (raw)
  * zlib (a.k.a. DEFLATE with a zlib wrapper)
  * gzip (a.k.a. DEFLATE with a gzip wrapper)
 .
 libdeflate is heavily optimized. It is significantly faster than the zlib
 library, both for compression and decompression, and especially on x86
 processors. In addition, libdeflate provides optional high compression modes
 that provide a better compression ratio than the zlib's "level 9".
 .
 This package provides the sample tools.

## libdeflate 1.6

=== Makefile ===
--- 
+++ 
@@ -25,6 +25,10 @@
 #
 # Define DESTDIR to override the installation destination directory
 # (default: empty string)
+#
+# Define FREESTANDING to build a freestanding library, i.e. a library that
+# doesn't link to any libc functions like malloc(), free(), and memcpy().
+# All users will need to call libdeflate_set_memory_allocator().
 #
 # You can also specify custom CFLAGS, CPPFLAGS, and/or LDFLAGS.
 #
@@ -41,7 +45,7 @@
 	      1>&2 2>/dev/null; then echo $(1); fi)
 
 override CFLAGS :=							\
-	-O2 -fomit-frame-pointer $(CFLAGS) -std=c99 -I. -Icommon	\
+	-O2 -fomit-frame-pointer $(CFLAGS) -std=c99 -I.			\
 	-Wall -Wundef							\
 	$(call cc-option,-Wpedantic)					\
 	$(call cc-option,-Wdeclaration-after-statement)			\
@@ -50,7 +54,11 @@
 	$(call cc-option,-Wvla)						\
 	$(call cc-option,-Wimplicit-fallthrough)
 
-# We don't define any CPPFLAGS, but support the user specifying it.
+FREESTANDING :=
+ifdef FREESTANDING
+override CPPFLAGS += -DFREESTANDING
+LIB_CFLAGS += -ffreestanding -nostdlib
+endif
 
 ##############################################################################
 
@@ -132,7 +140,7 @@
 
 LIB_HEADERS := $(wildcard lib/*.h) $(wildcard lib/*/*.h)
 
-LIB_SRC := lib/aligned_malloc.c lib/deflate_decompress.c \
+LIB_SRC := lib/deflate_decompress.c lib/utils.c \
 	   $(wildcard lib/*/cpu_features.c)
 
 DECOMPRESSION_ONLY :=
@@ -214,9 +222,7 @@
 TEST_PROG_COMMON_SRC := programs/test_util.c
 TEST_PROG_SRC        := programs/benchmark.c \
 			programs/checksum.c \
-			programs/test_checksums.c \
-			programs/test_incomplete_codes.c \
-			programs/test_slow_decompression.c
+			$(filter-out $(TEST_PROG_COMMON_SRC),$(wildcard programs/test_*.c))
 
 NONTEST_PROGRAMS := $(NONTEST_PROG_SRC:programs/%.c=%$(PROG_SUFFIX))
 DEFAULT_TARGETS  += $(NONTEST_PROGRAMS)

=== debian/changelog ===
libdeflate (1.6-1) unstable; urgency=medium

  * New upstream version
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Wrap long lines in changelog entries: 1.3-2.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Add new symbols
  * Mark libdeflate0 at Multi-Arch: same

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 13 May 2020 12:04:06 +0200

=== debian/control ===
--- 
+++ 
@@ -12,8 +12,10 @@
 Vcs-Browser: https://salsa.debian.org/med-team/libdeflate
 Vcs-Git: https://salsa.debian.org/med-team/libdeflate.git
 Homepage: https://github.com/ebiggers/libdeflate
+Rules-Requires-Root: no
 
 Package: libdeflate0
+Multi-Arch: same
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends},

## libdeflate 1.7

=== Makefile ===
--- 
+++ 
@@ -2,6 +2,9 @@
 # Use 'make help' to list available targets.
 #
 # Define V=1 to enable "verbose" mode, showing all executed commands.
+#
+# Define USE_SHARED_LIB to link the binaries to the shared library version of
+# libdeflate rather than to the static library version.
 #
 # Define DECOMPRESSION_ONLY to omit all compression code, building a
 # decompression-only library.  If doing this, you must also build a specific
@@ -30,7 +33,7 @@
 # doesn't link to any libc functions like malloc(), free(), and memcpy().
 # All users will need to call libdeflate_set_memory_allocator().
 #
-# You can also specify custom CFLAGS, CPPFLAGS, and/or LDFLAGS.
+# You can also specify a custom CC, CFLAGS, CPPFLAGS, and/or LDFLAGS.
 #
 ##############################################################################
 
@@ -45,19 +48,25 @@
 	      1>&2 2>/dev/null; then echo $(1); fi)
 
 override CFLAGS :=							\
-	-O2 -fomit-frame-pointer $(CFLAGS) -std=c99 -I.			\
-	-Wall -Wundef							\
+	-O2 -fomit-frame-pointer -std=c99 -I. -Wall -Wundef		\
 	$(call cc-option,-Wpedantic)					\
 	$(call cc-option,-Wdeclaration-after-statement)			\
 	$(call cc-option,-Wmissing-prototypes)				\
 	$(call cc-option,-Wstrict-prototypes)				\
 	$(call cc-option,-Wvla)						\
-	$(call cc-option,-Wimplicit-fallthrough)
+	$(call cc-option,-Wimplicit-fallthrough)			\
+	$(CFLAGS)
 
 FREESTANDING :=
 ifdef FREESTANDING
 override CPPFLAGS += -DFREESTANDING
 LIB_CFLAGS += -ffreestanding -nostdlib
+endif
+
+# Don't use this option except for testing; it isn't a stable interface.
+TEST_SUPPORT__DO_NOT_USE :=
+ifdef TEST_SUPPORT__DO_NOT_USE
+override CPPFLAGS += -DTEST_SUPPORT__DO_NOT_USE
 endif
 
 ##############################################################################
@@ -129,6 +138,26 @@
 
 ##############################################################################
 
+# Rebuild if a user-specified setting that affects the build changed.
+.build-config: FORCE
+	@flags=$$(							\
+		echo 'USE_SHARED_LIB=$(USE_SHARED_LIB)';		\
+		echo 'DECOMPRESSION_ONLY=$(DECOMPRESSION_ONLY)';	\
+		echo 'DISABLE_GZIP=$(DISABLE_GZIP)';			\
+		echo 'DISABLE_ZLIB=$(DISABLE_ZLIB)';			\
+		echo 'FREESTANDING=$(FREESTANDING)';			\
+		echo 'CC=$(CC)';					\
+		echo 'CFLAGS=$(CFLAGS)';				\
+		echo 'CPPFLAGS=$(CPPFLAGS)';				\
+		echo 'LDFLAGS=$(LDFLAGS)';				\
+	);								\
+	if [ "$$flags" != "`cat $@ 2>/dev/null`" ]; then		\
+		[ -e $@ ] && echo "Rebuilding due to new settings";	\
+		echo "$$flags" > $@;					\
+	fi
+
+##############################################################################
+
 COMMON_HEADERS := $(wildcard common/*.h) libdeflate.h
 DEFAULT_TARGETS :=
 
@@ -168,11 +197,11 @@
 SHARED_LIB_OBJ := $(LIB_SRC:.c=.shlib.o)
 
 # Compile static library object files
-$(STATIC_LIB_OBJ): %.o: %.c $(LIB_HEADERS) $(COMMON_HEADERS) .lib-cflags
+$(STATIC_LIB_OBJ): %.o: %.c $(LIB_HEADERS) $(COMMON_HEADERS) .build-config
 	$(QUIET_CC) $(CC) -o $@ -c $(CPPFLAGS) $(LIB_CFLAGS) $<
 
 # Compile shared library object files
-$(SHARED_LIB_OBJ): %.shlib.o: %.c $(LIB_HEADERS) $(COMMON_HEADERS) .lib-cflags
+$(SHARED_LIB_OBJ): %.shlib.o: %.c $(LIB_HEADERS) $(COMMON_HEADERS) .build-config
 	$(QUIET_CC) $(CC) -o $@ -c $(CPPFLAGS) $(LIB_CFLAGS) \
 		$(SHARED_LIB_CFLAGS) -DLIBDEFLATE_DLL $<
 
@@ -195,14 +224,6 @@
 	$(QUIET_LN) ln -sf $+ $@
 DEFAULT_TARGETS += $(SHARED_LIB_SYMLINK)
 endif
-
-# Rebuild if CC, LIB_CFLAGS, or CPPFLAGS changed
-.lib-cflags: FORCE
-	@flags='$(CC):$(LIB_CFLAGS):$(CPPFLAGS)'; \
-	if [ "$$flags" != "`cat $@ 2>/dev/null`" ]; then \
-		[ -e $@ ] && echo "Rebuilding library due to new compiler flags"; \
-		echo "$$flags" > $@; \
-	fi
 
 ##############################################################################
 
@@ -237,12 +258,12 @@
 			$(TEST_PROG_COMMON_OBJ) $(TEST_PROG_OBJ)
 
 # Generate autodetected configuration header
-programs/config.h:programs/detect.sh .prog-cflags
+programs/config.h:scripts/detect.sh .build-config
 	$(QUIET_GEN) CC="$(CC)" CFLAGS="$(PROG_CFLAGS)" $< > $@
 
 # Compile program object files
 $(ALL_PROG_OBJ): %.o: %.c $(ALL_PROG_COMMON_HEADERS) $(COMMON_HEADERS) \
-			.prog-cflags
+			.build-config
 	$(QUIET_CC) $(CC) -o $@ -c $(CPPFLAGS) $(PROG_CFLAGS) $<
 
 # Link the programs.
@@ -250,12 +271,17 @@
 # Note: the test programs are not compiled by default.  One reason is that the
 # test programs must be linked with zlib for doing comparisons.
 
-$(NONTEST_PROGRAMS): %$(PROG_SUFFIX): programs/%.o $(PROG_COMMON_OBJ) \
-			$(STATIC_LIB)
+ifdef USE_SHARED_LIB
+LIB := $(SHARED_LIB)
+else
+LIB := $(STATIC_LIB)
+endif
+
+$(NONTEST_PROGRAMS): %$(PROG_SUFFIX): programs/%.o $(PROG_COMMON_OBJ) $(LIB)
 	$(QUIET_CCLD) $(CC) -o $@ $(LDFLAGS) $(PROG_CFLAGS) $+
 
 $(TEST_PROGRAMS): %$(PROG_SUFFIX): programs/%.o $(PROG_COMMON_OBJ) \
-			$(TEST_PROG_COMMON_OBJ) $(STATIC_LIB)
+			$(TEST_PROG_COMMON_OBJ) $(LIB)
 	$(QUIET_CCLD) $(CC) -o $@ $(LDFLAGS) $(PROG_CFLAGS) $+ -lz
 
 ifdef HARD_LINKS
@@ -270,14 +296,6 @@
 
 DEFAULT_TARGETS += gunzip$(PROG_SUFFIX)
 
-# Rebuild if CC, PROG_CFLAGS, or CPPFLAGS changed
-.prog-cflags: FORCE
-	@flags='$(CC):$(PROG_CFLAGS):$(CPPFLAGS)'; \
-	if [ "$$flags" != "`cat $@ 2>/dev/null`" ]; then \
-		[ -e $@ ] && echo "Rebuilding programs due to new compiler flags"; \
-		echo "$$flags" > $@; \
-	fi
-
 ##############################################################################
 
 all:$(DEFAULT_TARGETS)
@@ -288,28 +306,43 @@
 	install -d $(DESTDIR)$(LIBDIR) $(DESTDIR)$(INCDIR) $(DESTDIR)$(BINDIR)
 	install -m644 $(STATIC_LIB) $(DESTDIR)$(LIBDIR)
 	install -m755 $(SHARED_LIB) $(DESTDIR)$(LIBDIR)
-	ln -sf $(SHARED_LIB) $(DESTDIR)$(LIBDIR)/libdeflate.so
 	install -m644 libdeflate.h $(DESTDIR)$(INCDIR)
-	install -m755 gzip $(DESTDIR)$(BINDIR)/libdeflate-gzip
-	ln -f $(DESTDIR)$(BINDIR)/libdeflate-gzip $(DESTDIR)$(BINDIR)/libdeflate-gunzip
+	install -m755 gzip$(PROG_SUFFIX) \
+		$(DESTDIR)$(BINDIR)/libdeflate-gzip$(PROG_SUFFIX)
+	ln -f $(DESTDIR)$(BINDIR)/libdeflate-gzip$(PROG_SUFFIX)		\
+	      $(DESTDIR)$(BINDIR)/libdeflate-gunzip$(PROG_SUFFIX)
+	if [ -n "$(SHARED_LIB_SYMLINK)" ]; then				\
+		ln -sf $(SHARED_LIB)					\
+		       $(DESTDIR)$(LIBDIR)/$(SHARED_LIB_SYMLINK);	\
+	fi
 
 uninstall:
-	rm -f $(DESTDIR)$(LIBDIR)/$(STATIC_LIB) \
-		$(DESTDIR)$(LIBDIR)/$(SHARED_LIB) \
-		$(DESTDIR)$(LIBDIR)/libdeflate.so \
-		$(DESTDIR)$(INCDIR)/libdeflate.h \
-		$(DESTDIR)$(BINDIR)/libdeflate-gzip \
-		$(DESTDIR)$(BINDIR)/libdeflate-gunzip
+	rm -f $(DESTDIR)$(LIBDIR)/$(STATIC_LIB)				\
+	      $(DESTDIR)$(LIBDIR)/$(SHARED_LIB)				\
+	      $(DESTDIR)$(INCDIR)/libdeflate.h				\
+	      $(DESTDIR)$(BINDIR)/libdeflate-gzip$(PROG_SUFFIX)		\
+	      $(DESTDIR)$(BINDIR)/libdeflate-gunzip$(PROG_SUFFIX)
+	if [ -n "$(SHARED_LIB_SYMLINK)" ]; then				\
+		rm -f $(DESTDIR)$(LIBDIR)/$(SHARED_LIB_SYMLINK);	\
+	fi
 
 test_programs:$(TEST_PROGRAMS)
 
 # A minimal 'make check' target.  This only runs some quick tests;
-# use tools/run_tests.sh if you want to run the full tests.
+# use scripts/run_tests.sh if you want to run the full tests.
 check:test_programs
-	./benchmark$(PROG_SUFFIX) < ./benchmark$(PROG_SUFFIX)
+	LD_LIBRARY_PATH=. ./benchmark$(PROG_SUFFIX) < ./benchmark$(PROG_SUFFIX)
 	for prog in test_*; do		\
-		./$$prog || exit 1;	\
+		LD_LIBRARY_PATH=. ./$$prog || exit 1;	\
 	done
+
+# Run the clang static analyzer.
+scan-build:
+	scan-build --status-bugs make all test_programs
+
+# Run shellcheck on all shell scripts.
+shellcheck:
+	shellcheck scripts/*.sh
 
 help:
 	@echo "Available targets:"
@@ -319,20 +352,17 @@
 	done
 
 clean:
-	rm -f *.a *.dll *.exe *.exp *.so \
+	rm -f *.a *.dll *.exe *.exp *.dylib *.so \
 		lib/*.o lib/*/*.o \
 		lib/*.obj lib/*/*.obj \
 		lib/*.dllobj lib/*/*.dllobj \
 		programs/*.o programs/*.obj \
 		$(DEFAULT_TARGETS) $(TEST_PROGRAMS) programs/config.h \
 		libdeflate.lib libdeflate.def libdeflatestatic.lib \
-		.lib-cflags .prog-cflags
+		.build-config
 
 realclean: clean
-	rm -f tags cscope* run_tests.log
+	rm -f tags cscope*
 
 FORCE:
 
-.PHONY: all install uninstall test_programs help clean realclean
-
-.DEFAULT_GOAL = all

=== scripts/afl-fuzz/Makefile ===
SRC := $(wildcard */*.c)
EXE := $(SRC:.c=)

CFLAGS := -O2 -s
LDLIBS := -ldeflate
LDFLAGS := -L../..
CPPFLAGS := -I../..

all:$(EXE)

clean:
	rm -f $(EXE)

=== debian/changelog ===
libdeflate (1.7-2ubuntu2) impish; urgency=medium

  * Merge with Debian; remaining changes:
    - remove an old patch that disables a test, it doesn't seem needed
      and the description is wrong, pointed out in the MIR review #1908502
  * Revert: debian/rules: Specify minimum FPU (-mfpu=vfpv3-d16) on armhf.
  * lib/arm/crc32_impl.h: Use "arch=armv8-a+simd+crc" as the target arch.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Aug 2021 11:50:07 +0200

libdeflate (1.7-2) unstable; urgency=medium

  * Team Upload
  * Fix FTCBFS: (Closes: #989942)
    + Let dh_auto_build pass cross tools to make.
    + Automatically skip pgo when DEB_BUILD_PROFILES contains cross.
    Thanks to Helmut Grohne!

 -- Nilesh Patra <nilesh@debian.org>  Sun, 22 Aug 2021 01:14:54 +0530

libdeflate (1.7-1ubuntu2) impish; urgency=medium

  * debian/rules: Specify minimum FPU (-mfpu=vfpv3-d16) on armhf

 -- Lukas Märdian <slyon@ubuntu.com>  Mon, 09 Aug 2021 17:25:50 +0200

libdeflate (1.7-1ubuntu1) hirsute; urgency=medium

  * debian/patches/simplify-tests:
    - remove an old patch that disables a test, it doesn't seem needed
      and the description is wrong, pointed out in the MIR review #1908502

 -- Sebastien Bacher <seb128@debian.org>  Tue, 09 Mar 2021 17:16:23 +0100

libdeflate (1.7-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Refresh patch

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 03 Jan 2021 14:36:39 +0100

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,15 @@
 Source: libdeflate
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Uploaders: Michael R. Crusoe <crusoe@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                d-shlibs,
                zlib1g-dev,
                python3 <!nocheck>,
                xxd <!nocheck>
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/libdeflate
 Vcs-Git: https://salsa.debian.org/med-team/libdeflate.git
 Homepage: https://github.com/ebiggers/libdeflate

=== debian/rules ===
#!/usr/bin/make -f

export LC_ALL=C.UTF-8

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

ifeq (,$(filter cross,$(DEB_BUILD_PROFILES)))
PROFILING_FLAG = -fprofile-use
else
PROFILING_FLAG =
endif

override_dh_auto_build:
ifeq (,$(filter cross,$(DEB_BUILD_PROFILES)))
	dh_auto_build -- CFLAGS="$(shell dpkg-buildflags --get CFLAGS) -fprofile-generate" \
		LDFLAGS="$(shell dpkg-buildflags --get LDFLAGS) -fprofile-generate"\
		CPPFLAGS="$(shell dpkg-buildflags --get CPPFLAGS)"\
		V=1 PREFIX=/usr DESTDIR=$(CURDIR)/debian/tmp \
		all test_programs
	for level in $(shell seq 1 12); do \
		./benchmark -$${level} ./lib/deflate_compress.c > /dev/null; \
	done
endif
	dh_auto_build -- CFLAGS="$(shell dpkg-buildflags --get CFLAGS) $(PROFILING_FLAG)" \
		LDFLAGS="$(shell dpkg-buildflags --get LDFLAGS) $(PROFILING_FLAG)"\
		CPPFLAGS="$(shell dpkg-buildflags --get CPPFLAGS)"\
		V=1 PREFIX=/usr DESTDIR=$(CURDIR)/debian/tmp \
		all test_programs

override_dh_auto_install:
	dh_auto_build -- CFLAGS="$(shell dpkg-buildflags --get CFLAGS) $(PROFILING_FLAG)" \
		LDFLAGS="$(shell dpkg-buildflags --get LDFLAGS) $(PROFILING_FLAG)"\
		CPPFLAGS="$(shell dpkg-buildflags --get CPPFLAGS)"\
		V=1 PREFIX=/usr DESTDIR=$(CURDIR)/debian/tmp \
		install

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test -- V=1
	# SMOKEDATA=$(CURDIR)/README.md WRAPPER= tools/run_tests.sh \
	# 	  -checksum_benchmarks -windows -android -mips \
	# 	  -static_analysis -native -valgrind
	# SMOKEDATA=$(CURDIR)/README.md WRAPPER= sh tools/exec_tests.sh
endif

override_dh_install:
	dh_install
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    debian/tmp/usr/lib/*.so

## libdeflate 1.10

=== Makefile ===
--- 
+++ 
@@ -5,6 +5,9 @@
 #
 # Define USE_SHARED_LIB to link the binaries to the shared library version of
 # libdeflate rather than to the static library version.
+#
+# Define DISABLE_SHARED to disable building and installing of shared library.
+# Defining this variable undefines USE_SHARED_LIB.
 #
 # Define DECOMPRESSION_ONLY to omit all compression code, building a
 # decompression-only library.  If doing this, you must also build a specific
@@ -36,6 +39,9 @@
 # You can also specify a custom CC, CFLAGS, CPPFLAGS, and/or LDFLAGS.
 #
 ##############################################################################
+
+VERSION = $(shell sed -n 's/\#define LIBDEFLATE_VERSION_STRING.*"\(.*\)"/\1/p' \
+	    libdeflate.h)
 
 #### Common compiler flags.  You can add additional flags by defining CFLAGS
 #### in the environment or on the 'make' command line.
@@ -83,8 +89,10 @@
 PROG_CFLAGS        :=
 HARD_LINKS         := 1
 
+TARGET_MACHINE     := $(shell $(CC) -dumpmachine 2>/dev/null)
+
 # Compiling for Windows with MinGW?
-ifneq ($(findstring -mingw,$(shell $(CC) -dumpmachine 2>/dev/null)),)
+ifneq ($(findstring -mingw,$(TARGET_MACHINE)),)
     STATIC_LIB_SUFFIX  := static.lib
     SHARED_LIB         := libdeflate.dll
     SHARED_LIB_SYMLINK :=
@@ -106,14 +114,21 @@
                 sed -E 's/g?cc(-?[0-9]+(\.[0-9]+)*)?(\.exe)?$$/ar\3/')
     endif
 
-# macOS?
-else ifeq ($(shell uname),Darwin)
+# Compiling for macOS?
+else ifneq ($(findstring -darwin,$(TARGET_MACHINE)),)
    SHARED_LIB         := libdeflate.$(SOVERSION).dylib
    SHARED_LIB_SYMLINK := libdeflate.dylib
    SHARED_LIB_CFLAGS  := -fPIC
    SHARED_LIB_LDFLAGS := -install_name $(SHARED_LIB)
 
-# Linux, FreeBSD, etc.
+# Compiling for Android?
+else ifneq ($(findstring -android,$(TARGET_MACHINE)),)
+   SHARED_LIB         := libdeflate.so
+   SHARED_LIB_SYMLINK :=
+   SHARED_LIB_CFLAGS  := -fPIC
+   SHARED_LIB_LDFLAGS := -Wl,-soname=$(SHARED_LIB)
+
+# Compiling for Linux, FreeBSD, etc.
 else
    SHARED_LIB         := libdeflate.so.$(SOVERSION)
    SHARED_LIB_SYMLINK := libdeflate.so
@@ -142,6 +157,7 @@
 .build-config: FORCE
 	@flags=$$(							\
 		echo 'USE_SHARED_LIB=$(USE_SHARED_LIB)';		\
+		echo 'DISABLE_SHARED=$(DISABLE_SHARED)';		\
 		echo 'DECOMPRESSION_ONLY=$(DECOMPRESSION_ONLY)';	\
 		echo 'DISABLE_GZIP=$(DISABLE_GZIP)';			\
 		echo 'DISABLE_ZLIB=$(DISABLE_ZLIB)';			\
@@ -216,7 +232,11 @@
 	$(QUIET_CCLD) $(CC) -o $@ $(LDFLAGS) $(LIB_CFLAGS) \
 		$(SHARED_LIB_LDFLAGS) -shared $+
 
+ifdef DISABLE_SHARED
+undefine SHARED_LIB_SYMLINK
+else
 DEFAULT_TARGETS += $(SHARED_LIB)
+endif
 
 ifdef SHARED_LIB_SYMLINK
 # Create the symlink libdeflate.so => libdeflate.so.$SOVERSION
@@ -300,12 +320,25 @@
 
 all:$(DEFAULT_TARGETS)
 
+# We don't generate the pkg-config file until install time, as needed
+# definitions might not exist until then.
+PKGCONFBASE := libdeflate.pc.in
+
 # Install the files.  Note: not all versions of the 'install' program have the
 # '-D' and '-t' options, so don't use them; use portable commands only.
-install:all
-	install -d $(DESTDIR)$(LIBDIR) $(DESTDIR)$(INCDIR) $(DESTDIR)$(BINDIR)
+install:all $(PKGCONFBASE)
+	install -d $(DESTDIR)$(LIBDIR)/pkgconfig $(DESTDIR)$(INCDIR)	\
+		$(DESTDIR)$(BINDIR)
 	install -m644 $(STATIC_LIB) $(DESTDIR)$(LIBDIR)
-	install -m755 $(SHARED_LIB) $(DESTDIR)$(LIBDIR)
+	if [ -z "$(DISABLE_SHARED)" ]; then				\
+		install -m755 $(SHARED_LIB) $(DESTDIR)$(LIBDIR);	\
+	fi
+	sed -e "s|@PREFIX@|$(PREFIX)|"					\
+	    -e "s|@LIBDIR@|$(LIBDIR)|"					\
+	    -e "s|@INCDIR@|$(INCDIR)|"					\
+	    -e "s|@VERSION@|$(VERSION)|"				\
+	    $(PKGCONFBASE) > $(DESTDIR)$(LIBDIR)/pkgconfig/libdeflate.pc
+	chmod 644 $(DESTDIR)$(LIBDIR)/pkgconfig/libdeflate.pc
 	install -m644 libdeflate.h $(DESTDIR)$(INCDIR)
 	install -m755 gzip$(PROG_SUFFIX) \
 		$(DESTDIR)$(BINDIR)/libdeflate-gzip$(PROG_SUFFIX)
@@ -319,50 +352,5 @@
 uninstall:
 	rm -f $(DESTDIR)$(LIBDIR)/$(STATIC_LIB)				\
 	      $(DESTDIR)$(LIBDIR)/$(SHARED_LIB)				\
+	      $(DESTDIR)$(LIBDIR)/pkgconfig/libdeflate.pc		\
 	      $(DESTDIR)$(INCDIR)/libdeflate.h				\
-	      $(DESTDIR)$(BINDIR)/libdeflate-gzip$(PROG_SUFFIX)		\
-	      $(DESTDIR)$(BINDIR)/libdeflate-gunzip$(PROG_SUFFIX)
-	if [ -n "$(SHARED_LIB_SYMLINK)" ]; then				\
-		rm -f $(DESTDIR)$(LIBDIR)/$(SHARED_LIB_SYMLINK);	\
-	fi
-
-test_programs:$(TEST_PROGRAMS)
-
-# A minimal 'make check' target.  This only runs some quick tests;
-# use scripts/run_tests.sh if you want to run the full tests.
-check:test_programs
-	LD_LIBRARY_PATH=. ./benchmark$(PROG_SUFFIX) < ./benchmark$(PROG_SUFFIX)
-	for prog in test_*; do		\
-		LD_LIBRARY_PATH=. ./$$prog || exit 1;	\
-	done
-
-# Run the clang static analyzer.
-scan-build:
-	scan-build --status-bugs make all test_programs
-
-# Run shellcheck on all shell scripts.
-shellcheck:
-	shellcheck scripts/*.sh
-
-help:
-	@echo "Available targets:"
-	@echo "------------------"
-	@for target in $(DEFAULT_TARGETS) $(TEST_PROGRAMS); do \
-		echo -e "$$target";		\
-	done
-
-clean:
-	rm -f *.a *.dll *.exe *.exp *.dylib *.so \
-		lib/*.o lib/*/*.o \
-		lib/*.obj lib/*/*.obj \
-		lib/*.dllobj lib/*/*.dllobj \
-		programs/*.o programs/*.obj \
-		$(DEFAULT_TARGETS) $(TEST_PROGRAMS) programs/config.h \
-		libdeflate.lib libdeflate.def libdeflatestatic.lib \
-		.build-config
-
-realclean: clean
-	rm -f tags cscope*
-
-FORCE:
-

=== debian/changelog ===
libdeflate (1.10-2) unstable; urgency=medium

  * Team Upload.
  * Add patch to fix FTBFS on armhf (Closes: #1006139)
    + Thanks to Graham Inggs for pointing towards Ubuntu patch

 -- Nilesh Patra <nilesh@debian.org>  Thu, 10 Mar 2022 23:35:02 +0530

libdeflate (1.10-1) unstable; urgency=medium

  * Team upload.
  * New upstream version

 -- Andreas Tille <tille@debian.org>  Sun, 20 Feb 2022 08:30:56 +0100

libdeflate (1.9-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Add missing build dependency on dh addon.
  * Install pkgconfig file

 -- Andreas Tille <tille@debian.org>  Wed, 19 Jan 2022 17:10:52 +0100

libdeflate (1.8-1) unstable; urgency=medium

  * Team upload.
  * Fix watchfile to detect new versions on github
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)

 -- Andreas Tille <tille@debian.org>  Sun, 10 Oct 2021 10:20:38 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: libdeflate
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Michael R. Crusoe <crusoe@debian.org>
 Section: science
 Priority: optional
@@ -8,8 +7,9 @@
                d-shlibs,
                zlib1g-dev,
                python3 <!nocheck>,
-               xxd <!nocheck>
-Standards-Version: 4.5.1
+               xxd <!nocheck>,
+               debhelper
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/libdeflate
 Vcs-Git: https://salsa.debian.org/med-team/libdeflate.git
 Homepage: https://github.com/ebiggers/libdeflate

=== debian/watch ===
version=4

https://github.com/ebiggers/libdeflate/releases/latest .*/v?@ANY_VERSION@@ARCHIVE_EXT@
# skips pre-releases

## libdeflate 1.12

=== debian/changelog ===
libdeflate (1.12-1) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * d/watch: Use proper filename for download

  [ Lance Lin ]
  * Updated to new version (1.12)

  [ Andreas Tille ]
  * Standards-Version: 4.6.1 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 23 Jun 2022 15:30:05 +0200

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/ebiggers/libdeflate/releases/latest .*/v?@ANY_VERSION@@ARCHIVE_EXT@
